export declare type RunTimeErrorOptions = {
    skipStackLines?: number;
    depth?: number;
    limitStackTrace?: number;
};
export declare class RuntimeError extends Error {
    name: string;
    details: any;
    detailsString: string;
    /**
     * @deprecated use options via object RunTimeErrorOptions instead
     * @param message
     * @param details
     * @param skipStackLines
     * @param depth
     */
    constructor(message: string, details: any, skipStackLines?: number, depth?: number);
    constructor(message: string, details: any, options?: RunTimeErrorOptions);
}
