export interface StrictMapOptions<K, V> {
    onNull?: (key: K, self: StrictMap<K, V>) => NonNullable<V> | void;
}
export declare class StrictMap<K, V> {
    nativeMap: Map<K, V>;
    constructor();
    ensure(key: K): void;
    get(key: any, options?: StrictMapOptions<K, V>): NonNullable<V>;
    set: (key: K, value: V) => Map<K, V>;
    has: (key: any) => boolean;
    keys: () => IterableIterator<K>;
    entries: () => IterableIterator<[K, V]>;
    clear: () => void;
    delete: (key: K) => boolean;
    values: () => IterableIterator<V>;
    get size(): number;
}
