"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.devAssert = devAssert;

var _RuntimeError = require("./RuntimeError");

function devAssert(message, details, options) {
  if (details) {
    throw new _RuntimeError.RuntimeError(message, details, options === null || options === void 0 ? void 0 : options.skipStackLines, options === null || options === void 0 ? void 0 : options.depth);
  }

  throw new Error(message);
}
//# sourceMappingURL=devAssert.js.map