"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getKeys = getKeys;
exports.hasProperty = hasProperty;
exports.objectEntries = objectEntries;

var _invariant = require("./invariant");

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function getKeys(obj) {
  return Object.keys(obj);
}

function objectEntries(obj) {
  (0, _invariant.invariantType)({
    obj: obj
  }, 'object');
  return Object.entries(obj);
}

function hasProperty(obj, prop) {
  return obj && _typeof(obj) === 'object' && obj.hasOwnProperty(prop);
}
//# sourceMappingURL=getKeys.js.map