"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.keyBy = keyBy;

function keyBy(arr, getKey, onDuplicate) {
  var temp = {};
  arr.forEach(function (el) {
    var key = getKey(el);

    if (onDuplicate && temp.hasOwnProperty(key)) {
      onDuplicate(key, el);
    }

    temp[key] = el;
  });
  return temp;
}
//# sourceMappingURL=keyBy.js.map