var _require = require('module'),
    builtinModules = _require.builtinModules;

var ignoreList = ['sys'];
export var BUILTIN_MODULES = new Set( // https://github.com/sindresorhus/builtin-modules/blob/main/index.js
(builtinModules || Object.keys(process.binding('natives'))).filter(function (x) {
  return !/^_|^(internal|v8|node-inspect)\/|\//.test(x) && !ignoreList.includes(x);
}).sort());
export function isBuiltInModule(moduleName) {
  return BUILTIN_MODULES.has(moduleName);
}
//# sourceMappingURL=buildInModules.js.map