"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  tuple: true,
  tupleNum: true,
  tupleEnum: true,
  A_Z: true,
  TypeAssertionError: true,
  A: true,
  B: true,
  C: true,
  F: true,
  I: true,
  L: true,
  M: true,
  N: true,
  O: true,
  S: true,
  T: true,
  U: true
};
Object.defineProperty(exports, "A", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.A;
  }
});
exports.A_Z = void 0;
Object.defineProperty(exports, "B", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.B;
  }
});
Object.defineProperty(exports, "C", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.C;
  }
});
Object.defineProperty(exports, "F", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.F;
  }
});
Object.defineProperty(exports, "I", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.I;
  }
});
Object.defineProperty(exports, "L", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.L;
  }
});
Object.defineProperty(exports, "M", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.M;
  }
});
Object.defineProperty(exports, "N", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.N;
  }
});
Object.defineProperty(exports, "O", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.O;
  }
});
Object.defineProperty(exports, "S", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.S;
  }
});
Object.defineProperty(exports, "T", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.T;
  }
});
exports.TypeAssertionError = void 0;
Object.defineProperty(exports, "U", {
  enumerable: true,
  get: function get() {
    return _tsToolbelt.U;
  }
});
exports.tupleNum = exports.tupleEnum = exports.tuple = void 0;

var _tsToolbelt = require("ts-toolbelt");

Object.keys(_tsToolbelt).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _tsToolbelt[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _tsToolbelt[key];
    }
  });
});

var _RuntimeError2 = require("./RuntimeError");

var _IterationMap = require("./IterationMap");

Object.keys(_IterationMap).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _IterationMap[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _IterationMap[key];
    }
  });
});

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var tuple = function tuple() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return args;
};

exports.tuple = tuple;

var tupleNum = function tupleNum() {
  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  return args;
};

exports.tupleNum = tupleNum;

var tupleEnum = function tupleEnum() {
  for (var _len3 = arguments.length, values = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    values[_key3] = arguments[_key3];
  }

  var en = values.reduce(function (p, n) {
    return _objectSpread(_objectSpread({}, p), {}, _defineProperty({}, n, n));
  }, Object.create(null));
  Object.defineProperty(en, en.list !== undefined ? '__list' : 'list', {
    enumerable: false,
    value: values
  });
  Object.defineProperty(en, en.enum !== undefined ? '__enum' : 'enum', {
    enumerable: false,
    get: function get() {
      return values[0];
    }
  });
  return en;
};

exports.tupleEnum = tupleEnum;
var A_Z = tuple('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '_');
exports.A_Z = A_Z;

var TypeAssertionError = /*#__PURE__*/function (_RuntimeError) {
  _inherits(TypeAssertionError, _RuntimeError);

  var _super = _createSuper(TypeAssertionError);

  function TypeAssertionError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'UNEXPECTED_VALUE';
    var details = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

    _classCallCheck(this, TypeAssertionError);

    return _super.call(this, message, details);
  }

  return _createClass(TypeAssertionError);
}(_RuntimeError2.RuntimeError);

exports.TypeAssertionError = TypeAssertionError;
//# sourceMappingURL=typeUtils.js.map