"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Process = void 0;
exports.useProcess = useProcess;

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

var defaultValue = {
  env: {},
  cwd: function cwd() {
    return '';
  },
  isMock: true
};

function useProcess() {
  if ((typeof process === "undefined" ? "undefined" : _typeof(process)) === 'object') return process;
  console.warn("process is not available at this environment");

  if ((typeof window === "undefined" ? "undefined" : _typeof(window)) === 'object') {
    window.process = window.process || defaultValue;
    return window.process;
  }

  return defaultValue;
}

var Process = useProcess();
exports.Process = Process;
//# sourceMappingURL=useProcess.js.map