export declare type CreateProxyOptions<T> = {
    onGet?: <K extends keyof T>(field: K) => T[K] | null;
    onSet?: <K extends keyof T>(field: K, v: any) => true | null;
    onHas?: <K extends keyof T>(field: K) => boolean | null;
};
export declare function createProxy<T extends Record<string, any>>(thunk: () => T, options?: CreateProxyOptions<T>): T;
