import { M } from './typeUtils';
export declare function deepFreeze<T extends Record<any, any>>(object: T): DeepFreeze<T>;
export declare type DeepFreeze<O> = {
    +readonly [K in keyof O]: O[K] extends M.BuiltIn ? O[K] : DeepFreeze<O[K]>;
};
export declare type DeepWritable<T> = {
    -readonly [K in keyof T]: T[K] extends Record<string, any> ? {
        [L in keyof DeepWritable<T[K]>]: DeepWritable<T[K]>[L];
    } : T[K];
};
export declare const freeze: typeof deepFreeze;
