"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.devAssert = void 0;
var RuntimeError_1 = require("./RuntimeError");
function devAssert(message, details, options) {
    if (details) {
        throw new RuntimeError_1.RuntimeError(message, details, options === null || options === void 0 ? void 0 : options.skipStackLines, options === null || options === void 0 ? void 0 : options.depth);
    }
    throw new Error(message);
}
exports.devAssert = devAssert;
