export declare class InvalidExpectedTypeError extends Error {
    fieldName: string;
    found: string;
    expected: string;
    constructor(fieldName: string, found: string, expected: string);
}
export declare class InvalidExpectedTruthyError extends Error {
    constructor(fieldName: string, value: any, foundType: string);
}
export declare function expectedType<Input extends {
    [key: string]: unknown;
}>(input: Input, expected: string | string[], optional?: boolean | 'truthy'): Input;
export declare const assertTypes: typeof expectedType;
