"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findModulePath = void 0;
var filePathCache = Object.create(null);
function findModulePath(moduleName, currentDirname) {
    var fs = require('fs');
    var ORIGINAL_REQUIRE = require;
    var cacheKey = "".concat(currentDirname, "_").concat(moduleName);
    if (filePathCache[cacheKey])
        return filePathCache[cacheKey];
    var filePath = ORIGINAL_REQUIRE.resolve(moduleName, {
        paths: __spreadArray([
            currentDirname
        ], __read((ORIGINAL_REQUIRE.resolve.paths(currentDirname) || [])), false),
    });
    if (!fs.existsSync(filePath)) {
        throw new Error("Cannot find module '".concat(moduleName, "'"));
    }
    return (filePathCache[cacheKey] = filePath);
}
exports.findModulePath = findModulePath;
