export declare type GetFieldByDotNotation<Obj, DotNotation> = DotNotation extends `${infer Left}.${infer Right}` ? Left extends keyof Obj ? GetFieldByDotNotation<Exclude<Obj[Left], undefined>, Right> | Extract<Obj[Left], undefined> : undefined : DotNotation extends keyof Obj ? Obj[DotNotation] : undefined;
export declare function getByPath<T, K extends string>(obj: T, key: K): GetFieldByDotNotation<T, K>;
