export declare function nonNullValues<T>(object: {
    [key in keyof T]: T[key] | null | undefined;
}, customMessage?: string): T;
export declare function notNull<T>(input: T | null | undefined, appendErrorMessage?: string): T;
export declare function invariant(truthy: boolean, errorMessage?: string, details?: any): void;
export declare function invariantType(object: object, type: string | string[], extraInfo?: any, depth?: number, skipLines?: number): boolean;
