"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.keyBy = void 0;
function keyBy(arr, getKey, onDuplicate) {
    var temp = {};
    arr.forEach(function (el) {
        var key = getKey(el);
        if (onDuplicate && temp.hasOwnProperty(key)) {
            onDuplicate(key, el);
        }
        temp[key] = el;
    });
    return temp;
}
exports.keyBy = keyBy;
