import { deepEqual } from 'fast-equals';
import { TypeAssertionError } from './typeUtils';
export function areEqual(a, b) {
  return deepEqual(a, b);
}
export function assertEqual(value, toBe) {
  var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'UNEXPECTED_VALUE';
  var details = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  if (!areEqual(value, toBe)) {
    throw new TypeAssertionError(message, details);
  }
}
//# sourceMappingURL=areEqual.js.map