import { RuntimeError } from './RuntimeError';
export function devAssert(message, details, options) {
  if (details) {
    throw new RuntimeError(message, details, options === null || options === void 0 ? void 0 : options.skipStackLines, options === null || options === void 0 ? void 0 : options.depth);
  }

  throw new Error(message);
}
//# sourceMappingURL=devAssert.js.map