import { invariantType } from './invariant';
export function getKeys(obj) {
  return Object.keys(obj);
}
export function objectEntries(obj) {
  invariantType({
    obj
  }, 'object');
  return Object.entries(obj);
}
export function hasProperty(obj, prop) {
  return obj && typeof obj === 'object' && obj.hasOwnProperty(prop);
}
//# sourceMappingURL=getKeys.js.map