"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.randomNames = exports.randomName = exports.randomItem = void 0;
var randomInt_1 = require("./randomInt");
var stringCase_1 = require("./stringCase");
function randomItem() {
    var list = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        list[_i] = arguments[_i];
    }
    //
    var _list = list.length === 1 && Array.isArray(list[0]) ? list[0] : list;
    return _list[(0, randomInt_1.randomInt)(0, _list.length - 1)];
}
exports.randomItem = randomItem;
function randomName() {
    var value = randomItem(exports.randomNames);
    return stringCase_1.stringCase.random(value);
}
exports.randomName = randomName;
exports.randomNames = [
    'Acre',
    'Alagoas',
    'Amazonas',
    'Amapá',
    'Bahia',
    'Ceará',
    'Distrito Federal',
    'Espírito Santo',
    'Goiás',
    'Maranhão',
    'Minas Gerais',
    'Mato Grosso do Sul',
    'Mato Grosso',
    'Pará',
    'Paraíba',
    'Pernambuco',
    'Piauí',
    'Paraná',
    'Rio de Janeiro',
    'Rio Grande do Norte',
    'Rondônia',
    'Roraima',
    'Rio Grande do Sul',
    'Santa Catarina',
    'Sergipe',
    'São Paulo',
    'Tocantins',
    'Rafaela',
    'Antonio',
    'Maggie',
    'Cacau',
];
Array(200).forEach(function () {
    var length = (0, randomInt_1.randomInt)(1, 7);
    var txt = __spreadArray([], __read(Array(length)), false).map(function () {
        return randomItem(exports.randomNames);
    })
        .join(' ');
    exports.randomNames.push(stringCase_1.stringCase.random(txt));
});
