"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeAssertionError = exports.A_Z = exports.tupleEnum = exports.tupleNum = exports.tuple = exports.S = exports.O = exports.I = exports.M = exports.F = exports.N = exports.C = exports.U = exports.A = exports.B = exports.L = exports.T = void 0;
// https://stackoverflow.com/questions/46176165/ways-to-get-string-literal-type-of-array-values-without-enum-overhead
var ts_toolbelt_1 = require("ts-toolbelt");
Object.defineProperty(exports, "A", { enumerable: true, get: function () { return ts_toolbelt_1.A; } });
Object.defineProperty(exports, "B", { enumerable: true, get: function () { return ts_toolbelt_1.B; } });
Object.defineProperty(exports, "C", { enumerable: true, get: function () { return ts_toolbelt_1.C; } });
Object.defineProperty(exports, "F", { enumerable: true, get: function () { return ts_toolbelt_1.F; } });
Object.defineProperty(exports, "I", { enumerable: true, get: function () { return ts_toolbelt_1.I; } });
Object.defineProperty(exports, "L", { enumerable: true, get: function () { return ts_toolbelt_1.L; } });
Object.defineProperty(exports, "M", { enumerable: true, get: function () { return ts_toolbelt_1.M; } });
Object.defineProperty(exports, "N", { enumerable: true, get: function () { return ts_toolbelt_1.N; } });
Object.defineProperty(exports, "O", { enumerable: true, get: function () { return ts_toolbelt_1.O; } });
Object.defineProperty(exports, "S", { enumerable: true, get: function () { return ts_toolbelt_1.S; } });
Object.defineProperty(exports, "T", { enumerable: true, get: function () { return ts_toolbelt_1.T; } });
Object.defineProperty(exports, "U", { enumerable: true, get: function () { return ts_toolbelt_1.U; } });
var RuntimeError_1 = require("./RuntimeError");
__exportStar(require("ts-toolbelt"), exports);
var tuple = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return args;
};
exports.tuple = tuple;
var tupleNum = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return args;
};
exports.tupleNum = tupleNum;
var tupleEnum = function () {
    var values = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        values[_i] = arguments[_i];
    }
    var en = values.reduce(function (p, n) {
        var _a;
        return __assign(__assign({}, p), (_a = {}, _a[n] = n, _a));
    }, Object.create(null));
    Object.defineProperty(en, en.list !== undefined ? '__list' : 'list', {
        enumerable: false,
        value: values,
    });
    Object.defineProperty(en, en.enum !== undefined ? '__enum' : 'enum', {
        enumerable: false,
        get: function () {
            return values[0];
        },
    });
    return en;
};
exports.tupleEnum = tupleEnum;
exports.A_Z = (0, exports.tuple)('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '_');
__exportStar(require("./IterationMap"), exports);
var TypeAssertionError = /** @class */ (function (_super) {
    __extends(TypeAssertionError, _super);
    function TypeAssertionError(message, details) {
        if (message === void 0) { message = 'UNEXPECTED_VALUE'; }
        if (details === void 0) { details = undefined; }
        return _super.call(this, message, details) || this;
    }
    return TypeAssertionError;
}(RuntimeError_1.RuntimeError));
exports.TypeAssertionError = TypeAssertionError;
