export declare function areEqual(a: any, b: any): boolean;
export declare type Assertable = string | boolean | number | AssertableList | Readonly<AssertableList> | {
    readonly [K: string]: unknown;
};
interface AssertableList extends Array<Assertable> {
}
export declare function assertEqual<ToBe extends Readonly<Assertable>>(value: unknown, toBe: ToBe, message?: string, details?: {}): asserts value is ToBe extends Assertable ? ToBe : never;
export {};
