"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BUILTIN_MODULES = void 0;
exports.isBuiltInModule = isBuiltInModule;

var _require = require('module'),
    builtinModules = _require.builtinModules;

var ignoreList = ['sys'];
var BUILTIN_MODULES = new Set( // https://github.com/sindresorhus/builtin-modules/blob/main/index.js
(builtinModules || Object.keys(process.binding('natives'))).filter(function (x) {
  return !/^_|^(internal|v8|node-inspect)\/|\//.test(x) && !ignoreList.includes(x);
}).sort());
exports.BUILTIN_MODULES = BUILTIN_MODULES;

function isBuiltInModule(moduleName) {
  return BUILTIN_MODULES.has(moduleName);
}
//# sourceMappingURL=builtin-modules.js.map