function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { RuntimeError } from './RuntimeError';
export var StrictMap = /*#__PURE__*/function () {
  function StrictMap() {
    var _this = this;

    _classCallCheck(this, StrictMap);

    _defineProperty(this, "nativeMap", void 0);

    _defineProperty(this, "set", function (key, value) {
      return _this.nativeMap.set(key, value);
    });

    _defineProperty(this, "has", function (key) {
      return _this.nativeMap.has(key);
    });

    _defineProperty(this, "keys", function () {
      return _this.nativeMap.keys();
    });

    _defineProperty(this, "entries", function () {
      return _this.nativeMap.entries();
    });

    _defineProperty(this, "clear", function () {
      return _this.nativeMap.clear();
    });

    _defineProperty(this, "delete", function (key) {
      return _this.nativeMap.delete(key);
    });

    _defineProperty(this, "values", function () {
      return _this.nativeMap.values();
    });

    this.nativeMap = new Map();
  }

  _createClass(StrictMap, [{
    key: "ensure",
    value: function ensure(key) {
      this.get(key);
    }
  }, {
    key: "get",
    value: function get(key) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!this.nativeMap.has(key)) {
        var onNull = options.onNull;

        if (onNull) {
          var newItem = onNull(key, this);

          if (newItem) {
            this.set(key, newItem);
            return newItem;
          }
        }

        throw new StrictMapError("There is no item with key \"".concat(key, "\""), {
          validKeys: _toConsumableArray(this.nativeMap.keys())
        });
      }

      var value = this.nativeMap.get(key);

      if (value === undefined || value === null) {
        throw new StrictMapError("Expected value to be not nullable, but received ".concat(value === null ? 'null' : 'undefined', "."), {
          validKeys: _toConsumableArray(this.nativeMap.keys())
        });
      }

      return value;
    }
  }, {
    key: "size",
    get: function get() {
      return this.nativeMap.size;
    }
  }]);

  return StrictMap;
}();

var StrictMapError = /*#__PURE__*/function (_RuntimeError) {
  _inherits(StrictMapError, _RuntimeError);

  var _super = _createSuper(StrictMapError);

  function StrictMapError(message, details) {
    var _this2;

    _classCallCheck(this, StrictMapError);

    _this2 = _super.call(this, message, details);
    _this2.name = 'StrictMapError';
    return _this2;
  }

  return _createClass(StrictMapError);
}(RuntimeError);
//# sourceMappingURL=StrictMap.js.map