function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

import clone from 'fast-copy';
import { RuntimeError } from './RuntimeError';
import { sortObject } from './sortObject';
export function simpleObjectClone(input) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    sort: false
  };
  var sort = options.sort;

  if (!input || _typeof(input) !== 'object') {
    throw new RuntimeError('input is not a valid object', {
      input: input
    });
  }

  try {
    var res = clone(input);
    return sort ? sortObject(res) : res;
  } catch (e) {
    debugger;
    throw new RuntimeError('Failed to execute JSON.stringify() on input object', {
      input: input
    });
  }
}
//# sourceMappingURL=simpleObjectClone.js.map