"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.randomFloat = randomFloat;
exports.randomInt = randomInt;
exports.randomNumber = void 0;

function randomInt() {
  var lower = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var upper = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
  return lower + Math.floor(Math.random() * (upper - lower + 1));
}

function randomFloat() {
  var lower = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var upper = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
  return lower + +"".concat(randomInt(0), ".").concat(randomInt(0, 9)).concat(randomInt(0, 9)) * (upper - lower + 1);
}

var randomNumber = randomFloat;
exports.randomNumber = randomNumber;
//# sourceMappingURL=randomInt.js.map