"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isBuiltInModule = exports.BUILTIN_MODULES = void 0;
var builtinModules = require('module').builtinModules;
var ignoreList = ['sys'];
exports.BUILTIN_MODULES = new Set(
// https://github.com/sindresorhus/builtin-modules/blob/main/index.js
(builtinModules || Object.keys(process.binding('natives')))
    .filter(function (x) {
    return !/^_|^(internal|v8|node-inspect)\/|\//.test(x) &&
        !ignoreList.includes(x);
})
    .sort());
function isBuiltInModule(moduleName) {
    return exports.BUILTIN_MODULES.has(moduleName);
}
exports.isBuiltInModule = isBuiltInModule;
