"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasProperty = exports.objectEntries = exports.getKeys = void 0;
var invariant_1 = require("./invariant");
function getKeys(obj) {
    return Object.keys(obj);
}
exports.getKeys = getKeys;
function objectEntries(obj) {
    (0, invariant_1.invariantType)({ obj: obj }, 'object');
    return Object.entries(obj);
}
exports.objectEntries = objectEntries;
function hasProperty(obj, prop) {
    return obj && typeof obj === 'object' && obj.hasOwnProperty(prop);
}
exports.hasProperty = hasProperty;
