function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import { getTypeName } from './getTypeName';
describe('getTypeName', () => {
  it('works', /*#__PURE__*/_asyncToGenerator(function* () {
    expect(getTypeName(Infinity)).toBe('Infinity');
    expect(getTypeName(NaN)).toBe('NaN');
    expect(getTypeName(1)).toBe('Number');
    expect(getTypeName(-1)).toBe('Number');
    expect(getTypeName('')).toBe('String');
    expect(getTypeName(new Date())).toBe('Date');
    expect(getTypeName(true)).toBe('Boolean');
    expect(getTypeName(new class Foo {}())).toBe('Foo');
  }));
});
//# sourceMappingURL=getTypeName.spec.js.map