export function keyBy(arr, getKey, onDuplicate) {
  var temp = {};
  arr.forEach(el => {
    var key = getKey(el);

    if (onDuplicate && temp.hasOwnProperty(key)) {
      onDuplicate(key, el);
    }

    temp[key] = el;
  });
  return temp;
}
//# sourceMappingURL=keyBy.js.map