var defaultValue = {
  env: {},

  cwd() {
    return '';
  },

  isMock: true
};
export function useProcess() {
  if (typeof process === 'object') return process;
  console.warn("process is not available at this environment");

  if (typeof window === 'object') {
    window.process = window.process || defaultValue;
    return window.process;
  }

  return defaultValue;
}
export var Process = useProcess();
//# sourceMappingURL=useProcess.js.map