import { TLogLevel } from './logLevels';
export declare class NodeLogger {
    private prefix;
    static lastLogged: {
        data: any;
        extraInfo: any;
    } | null;
    constructor(prefix?: string);
    object(object: Record<string, any>, depth?: number): void;
    error(err: any, extraInfo?: any): void;
    criticalError(err: any, extraInfo?: any): void;
    warn(data: any): void;
    info(data: any): void;
    debug(data: any): void;
    log(level: TLogLevel, data: any, extraInfo?: any): void;
    static logError: (err: any, extraInfo?: any) => void;
    static logCriticalError: (err: any, extraInfo?: any) => void;
    static log: (level: TLogLevel, data: any) => void;
    static logWarning: (data: any) => void;
    static logInfo: (data: any) => void;
    static debug: (data: any) => void;
}
export declare function inspect(arg: any, depth?: number): string;
