export * from 'deep-object-diff';
export declare type ObjectDiff = {
    kind: 'add' | 'remove' | 'update';
    newValue: any;
    oldValue: any;
    path: string;
    paths: string[];
};
export declare function objectDiffPaths(originObject: Record<string, any>, newObject: Record<string, any>): ObjectDiff[];
export declare const getObjectDiffPaths: typeof objectDiffPaths;
