"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Process = exports.useProcess = void 0;
var defaultValue = {
    env: {},
    cwd: function () {
        return '';
    },
    isMock: true,
};
function useProcess() {
    if (typeof process === 'object')
        return process;
    console.warn("process is not available at this environment");
    if (typeof window === 'object') {
        window.process = window.process || defaultValue;
        return window.process;
    }
    return defaultValue;
}
exports.useProcess = useProcess;
exports.Process = useProcess();
